package cokr.xit.fims.excl.dao;

import java.util.List;
import java.util.Map;

import org.egovframe.rte.psl.dataaccess.mapper.Mapper;

import cokr.xit.fims.excl.CrdnReReg;
import cokr.xit.fims.excl.ExclQuery;
import cokr.xit.foundation.component.AbstractMapper;
import cokr.xit.foundation.data.DataObject;

/** 단속 재등록 정보 DAO
 *
 * <p>상세 설명: 단속 재등록 대장 테이블에 접근하여 데이터를 조회하고 저장한다.
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-07-03	JoJH 최초 작성
 * ================================
 * </pre>
 */
@Mapper("crdnReRegMapper")
public interface CrdnReRegMapper extends AbstractMapper {

	/**지정한 조건에 따라 단속 재등록 목록을 조회하여 반환한다.<br />
	 * @param req 단속 재등록 조회 조건
	 * @return 단속 재등록 목록
	 */
	List<DataObject> selectCrdnReRegList(ExclQuery req);

	/**지정한 조건에 따라 단속 재등록 객체들을 반환한다.
	 * @param req 단속 재등록 조회 조건
	 * @return 단속 재등록 객체 목록
	 */
	List<DataObject> selectCrdnReRegs(ExclQuery req);

	/**단속 재등록 정보를 등록한다.
	 * @param params 파라미터
	 * <ul><li>"crdnReReg" - 단속 재등록</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int insertCrdnReReg(Map<String, Object> params);

	/**단속 재등록 정보를 등록한다.
	 * @param crdnReReg 단속 재등록
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean insert(CrdnReReg crdnReReg) {
		return crdnReReg != null && insertCrdnReReg(params().set("crdnReReg", crdnReReg)) == 1;
	}

	/**지정한 단속 재등록을 삭제한다.
	 * @param params 파라미터
	 * <ul><li>"crdnReReg" - 단속 재등록</li>
	 *     <li>"currentUser" - 현재 접속한 사용자</li>
	 * </ul>
	 * @return 저장된 정보수
	 */
	int deleteCrdnReReg(Map<String, ?> params);

	/**단속 재등록 정보를 삭제한다.
	 * @param crdnReReg 단속 재등록
	 * @return 저장 여부
	 * <ul><li>저장됐으면 true</li>
	 *     <li>그렇지 않으면 false</li>
	 * </ul>
	 */
	default boolean delete(CrdnReReg crdnReReg) {
		return crdnReReg != null && deleteCrdnReReg(params().set("crdnReReg", crdnReReg)) == 1;
	}

	/**지정한 단속ID의 단속 대장 정보를 반환한다.
	 * @param crdnId 단속ID
	 * @return 단속 대장 정보
	 */
	DataObject selectCrdn(ExclQuery req);

	default DataObject selectCrdnInfo(String crdnId) {
		return selectCrdn(new ExclQuery().setCrdnId(crdnId));
	}

}
